/***************************************************************
 * Atmega32 SImple OS Demo
 * Walter Schilling, Instructor
 * September, 2011
 *
 * This file demonstrates the usage of the ATMEGA32 simple OS.
 * In essence, it contains a simple application with three processes
 * (in reality, more like three threads) which turn LED's on and off
 * in succession on PORT B when using the Robokits ATMEGA32 development
 * board.
 ***************************************************************
 */
/*#include "driverlib/rom.h"

#include "inc/hw_types.h"
#include "inc/hw_memmap.h"
#include "driverlib/sysctl.h"
#include "driverlib/gpio.h"
#include "inc/hw_ints.h"
#include "inc/hw_memmap.h"
#include "inc/hw_types.h"
#include "driverlib/debug.h"
#include "driverlib/fpu.h"
#include "driverlib/gpio.h"
#include "driverlib/interrupt.h"
#include "driverlib/pin_map.h"
#include "driverlib/rom.h"
#include "driverlib/rom.h"
#include "driverlib/sysctl.h"
#include "driverlib/timer.h"
#include "utils/uartstdio.h"*/
#include <stdint.h>
#include "portdef.h"
#include "delay.h"
#include "os.h"
#include "inc/hw_ints.h"
#include "inc/hw_memmap.h"
#include "inc/hw_types.h"


#include "driverlib/debug.h"
#include "driverlib/fpu.h"
#include "driverlib/gpio.h"
#include "driverlib/interrupt.h"
#include "driverlib/pin_map.h"
#include "driverlib/rom.h"
#include "driverlib/sysctl.h"
#include "driverlib/timer.h"
#include "utils/uartstdio.h"

extern uint32_t stackp;


//*****************************************************************************
//
// Flags that contain the current value of the interrupt indicator as displayed
// on the UART.
//
//*****************************************************************************
#define RED_LED   GPIO_PIN_1
#define BLUE_LED  GPIO_PIN_2
#define GREEN_LED GPIO_PIN_3
#define ORANGE_LED GPIO_PIN_4

void p1();
void p2();
void p3();


/* Main
 * This is the main method.  It will
 * #1 Start the OS.
 * #2 Spawn process #2.
 * #3 Wait a bit
 * #4 Spawn process #3
 * #5 Execute p1.
 */
int main(int argc, char *argv[])
{
  int8_t p1ID;
  int8_t p2ID;
  int8_t p3ID;

  // Set PORTB as an output port to drive the LEDs.
  //
  // Setup the system clock to run at 50 Mhz from PLL with crystal reference
  //
  SysCtlClockSet(SYSCTL_SYSDIV_4|SYSCTL_USE_PLL|SYSCTL_XTAL_16MHZ|
                  SYSCTL_OSC_MAIN);

  //
  // Enable and configure the GPIO port for the LED operation.
  //
  SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOF);
  GPIOPinTypeGPIOOutput(GPIO_PORTF_BASE, RED_LED|BLUE_LED|GREEN_LED);
  GPIOPinWrite(GPIO_PORTF_BASE, RED_LED|BLUE_LED|GREEN_LED|ORANGE_LED, 0);

   //
  // Set the clocking to run directly from the crystal.
  //
  ROM_SysCtlClockSet(SYSCTL_SYSDIV_1 | SYSCTL_USE_OSC | SYSCTL_OSC_MAIN |
                     SYSCTL_XTAL_16MHZ);


  //
  // Enable the GPIO port that is used for the on-board LED.
  //
  ROM_SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOF);

  //
  // Enable the GPIO pins for the LED (PF1 & PF2).
  //
  ROM_GPIOPinTypeGPIOOutput(GPIO_PORTF_BASE, GPIO_PIN_2 | GPIO_PIN_1);



  startOS();
  //p1ID = addProcess(p1);
  //delay(1000);

  p2ID = addProcess(p2);
  //delay(1000);

  p3ID = addProcess(p3);
  //delay(10000);
  //terminateProcess(p2ID);

  while (1==1)
  {
        //
	    // Turn on the LED
	    //
	    GPIOPinWrite(GPIO_PORTF_BASE, BLUE_LED, BLUE_LED);
		delay(500);

	    GPIOPinWrite(GPIO_PORTF_BASE, BLUE_LED, 0);
		delay(500);
  }
}

/***************************************************************
 * This is p3.  It will blink LED 2 every 4 seconds.
 *
 ***************************************************************/
void p3()
{
    //
    // Turn on the LED
    //
    GPIOPinWrite(GPIO_PORTF_BASE, RED_LED, RED_LED);
	delay(4000);

    GPIOPinWrite(GPIO_PORTF_BASE, RED_LED, 0);
	delay(4000);
}

/***************************************************************
 * This is p2.  It will blink LED 2 every 1 seconds.
 *
 ***************************************************************/
void p2()
{
  while (1==1)
  {

	    //
	    // Turn on the LED
	    //
	    GPIOPinWrite(GPIO_PORTF_BASE, GREEN_LED, GREEN_LED);
		delay(2000);

	    GPIOPinWrite(GPIO_PORTF_BASE, GREEN_LED, 0);
		delay(2000);
  }
}

/***************************************************************
 * This is p1.  It will blink LED 0 every 1 seconds.
 *
 ***************************************************************/
void p1()
{
  while (1==1)
  {
	    //
	    // Turn on the LED
	    //
	    GPIOPinWrite(GPIO_PORTF_BASE, BLUE_LED, BLUE_LED);
		delay(2000);

	    GPIOPinWrite(GPIO_PORTF_BASE, BLUE_LED, 0);
		delay(2000);
  }
}



