/***************************************************************
 * Atmega32 SImple OS
 * Walter Schilling, Instructor
 * September, 2011
 *
 * This file contains simple delay routines.
 ***************************************************************
 */
#include "delay.h"
#include "inc/hw_types.h"
#include "driverlib/sysctl.h"


extern void getsp(); /* declare external asm function */


/***************************************************************
 * delayms
 * This method will delay 1ms.
 * Parameters:
 *  None
 * Return
 *  None
 ***************************************************************/
void delayms()
{
  uint16_t count;
  SysCtlDelay(6500);
}

/***************************************************************
 * delay
 * This method will delay for length ms.
 *
 * Parameters:
 *  length (uint16_t) This si the delay in ms for the routine.
 * Return
 *   None
 ***************************************************************/
void delay(uint16_t length)
{
	getsp();

  while (length>0)
  {
    delayms();
    length--;
  }
}
